C  CONTROL BLOCK FOR THE DEVICE-DEPENDENT AREA EXTENSION FOR THE
C  GENERIC WORKSTATION.
      SAVE          /UGPI00/
C  NUMBER OF HALF WORDS IN THE OUTPUT BUFFER.
      INTEGER       DDXZ1
      PARAMETER     (DDXZ1=1024)
C  NUMBER OF WORDS IN A SEGMENT TABLE ENTRY.
      INTEGER       DDXZ2
      PARAMETER     (DDXZ2=3)
C  CONTROL BLOCK LENGTH.
      INTEGER       DDXZZ
      PARAMETER     (DDXZZ=572)
C  THE DECLARATION OF THE COMMON BLOCK.
      COMMON        /UGPI00/
     X              DDXID,
     X              DDXB1,DDXS2,
     X              DDXBF,
     X              DDXPE,DDXNE,DDXME,
     X              DDXCN,DDXSB,
     X              DDXEF,DDXLS,DDXSF,DDXTF,
     X              DDXCZ,DDXCK,DDXCD,DDXCR,DDXCA,
     X              DDXSC,
     X              DDXCI,DDXCC,DDXCB,DDXCL,DDXCP,DDXCF,
     X              DDXAZ,DDXAR,
     X              DDXIO,DDXHT,DDXHQ
C  DEVICE-DEPENDENT AREA EXTENSION IDENTIFICATION.
      CHARACTER*8   DDXID
C  POINTER TO SUBROUTINE UGB001.
      INTEGER       DDXB1
C  POINTER TO SUBROUTINE UGPI02.
      INTEGER       DDXS2
C  THE INPUT/OUTPUT BUFFER.
      INTEGER*2     DDXBF(DDXZ1)
C  POINTER TO THE SEGMENT TABLE.  EACH ENTRY IN THIS TABLE CONTAINS
C  DDXZ2 WORDS.  THE MEANING OF EACH WORD IS:
C    1  EXTERNAL IDENTIFICATION OF THE SEGMENT.
C    2  INCLUDE/OMIT STATUS (0 MEANS INCLUDE, 1 MEANS OMIT).
C    3  PICK/NOPICK STATUS (0 MEANS NOPICK, 1 MEANS PICK).
      INTEGER       DDXPE
C  CURRENT NUMBER OF SEGMENTS IN THE SEGMENT TABLE.
      INTEGER       DDXNE
C  MAXIMUM NUMBER OF SEGMENTS THAT CAN BE PUT INTO THE SEGMENT
C  TABLE.
      INTEGER       DDXME
C  CONNECTION TYPE.
      INTEGER       DDXCN
C  SWAP BYTES FLAG:
C    0  MEANS DO NOT SWAP BYTES, AND
C    1  MEANS SWAP BYTES.
      INTEGER       DDXSB
C  SEGMENT ERASE FLAG:
C    0  MEANS SEGMENT IS BEING DRAWN, AND
C    1  MEANS SEGMENT IS BEING ERASED.
      INTEGER       DDXEF
C  LINE STRUCTURE FLAG:
C    0  MEANS DASHED, DOTTED, AND DOT-DASHED LINES CANNOT BE DRAWN,
C       AND
C    1  MEANS THEY CAN BE DRAWN.
      INTEGER       DDXLS
C  THREE-DIMENSIONAL SCISSORING FLAG:
C    0  MEANS SCISSORING OCCURS AT WORLD VOLUME, AND
C    1  MEANS IT OCCURS AT OBJECT VOLUME.
      INTEGER       DDXSF
C  THREE-DIMENSIONAL VIEWING TRANSFORMATION RETRIEVAL FLAG:
C    0  MEANS THE WORKSTATION CANNOT RETURN THE TRANSFORMATION, AND
C    1  MEANS IT CAN.
      INTEGER       DDXTF
C  NUMBER OF DIFFERENT HARDWARE GENERATED CHARACTER SIZES (-1 MEANS
C  ALL SIZES ARE POSSIBLE).
      INTEGER       DDXCZ
C  INDEX OF THE CHARACTER SIZE FOR THE KEYBOARD INPUT BUFFER.
      INTEGER       DDXCK
C  DATA FOR UP TO EIGHT CHARACTER SIZES:
C    DDXCD(1,*)  IS THE CHARACTER SPACING,
C    DDXCD(2,*)  IS THE X OFFSET FROM THE CENTER OF THE CHARACTER
C                TO THE LOCATION POINT, AND
C    DDXCD(3,*)  IS THE Y OFFSET.
      INTEGER       DDXCD(3,8)
C  NUMBER OF DIFFERENT HARDWARE GENERATED CHARACTER ROTATIONS (-1
C  MEANS ALL ROTATIONS ARE POSSIBLE).
      INTEGER       DDXCR
C  DATA FOR UP TO EIGHT ROTATIONS.
      INTEGER       DDXCA(8)
C  SCREEN CLEAR FLAG:
C    0  MEANS THE SCREEN IS CLEAR, AND
C    1  MEANS THE SCREEN IS NOT CLEAR.
      INTEGER       DDXSC
C  CURRENT INTENSITY LEVEL.
      INTEGER       DDXCI
C  CURRENT COLOR INDEX.
      INTEGER       DDXCC
C  CURRENT BLINK MODE.
      INTEGER       DDXCB
C  CURRENT LINE STRUCTURE.
      INTEGER       DDXCL
C  CURRENT PICK IDENTIFIER AND AVAILABILITY FLAG.
      INTEGER       DDXCP
      LOGICAL       DDXCF
C  ACTUAL SIZE OF THE CURRENT CHARACTERS.
      INTEGER       DDXAZ
C  ACTUAL ROTATION ANGLE OF THE CURRENT CHARACTERS.
      INTEGER       DDXAR
C  INPUT/OUTPUT IDENTIFICATION VALUE.
      INTEGER       DDXIO
C  THE FOLLOWING ARRAY OVERLAYS THE ENTIRE DDA EXTENSION.
      INTEGER       DDXRY(DDXZZ)
      EQUIVALENCE   (DDXRY(1),DDXID)
