C  CONTROL BLOCK FOR THE DEVICE-DEPENDENT AREA EXTENSION FOR
C  GENERATING DISPLAY FILES FOR TEKTRONIX 4010/4014 EMULATORS
C  IN A SEQUENTIAL DATA SET.
      SAVE          /UGXA00/
C  NUMBER OF CHARACTERS IN THE OUTPUT BUFFER.
      INTEGER       DDXZ1
      PARAMETER     (DDXZ1=80)
C  X AND Y LIMITS OF COORDINATES IN THE TERMINAL SPACE.
      INTEGER       DDXZ2,DDXZ3
      PARAMETER     (DDXZ2=4095,DDXZ3=3119)
C  CONTROL BLOCK LENGTH.
      INTEGER       DDXZZ
      PARAMETER     (DDXZZ=107)
C  THE DECLARATION OF THE COMMON BLOCK.
      COMMON        /UGXA00/
     X              DDXID,
     X              DDXBF,DDXBM,DDXBN,
     X              DDXLR,DDXNO,
     X              DDXGS,
     X              DDXCZ,DDXNC,
     X              DDXBP,DDXN1,DDXEP,DDXN2,
     X              DDXBR,DDXN3,DDXER,DDXN4,
     X              DDXCL,DDXN5,DDXIL,DDXX1,DDXNI,
     X              DDXBE,DDXN6,
     X              DDXPI,DDXLT,DDXTZ,
     X              DDXFF,DDXOP,DDXX2,
     X              DDXEC,DDXTO,DDXAS,
     X              DDXP1,DDXP2,DDXX3,
     X              DDXPA,DDXPN,DDXPL,DDXDL,
     X              DDXPV,DDXDC,
     X              DDXIO
C  DEVICE-DEPENDENT AREA EXTENSION IDENTIFICATION.
      CHARACTER*8   DDXID
C  THE INPUT/OUTPUT BUFFER.
      CHARACTER*(DDXZ1) DDXBF
C  MAXIMUM NUMBER OF CHARACTERS THAT WILL FIT INTO THE INPUT/OUTPUT
C  BUFFER.
      INTEGER       DDXBM
C  NUMBER OF CHARACTERS CURRENTLY IN THE INPUT/OUTPUT BUFFER.
      INTEGER       DDXBN
C  LOW RESOLUTION FLAG:
C    0 MEANS USE HIGH (4014) RESOLUTION, AND
C    1 MEANS USE LOW (4010) RESOLUTION.
      INTEGER       DDXLR
C  NO OPTIMIZATION FLAG:
C    0 MEANS DO THE OPTIMIZATION, AND
C    1 MEANS DO NOT DO THE OPTIMIZATION.
      INTEGER       DDXNO
C  GENERATE LINE STRUCTURE FLAG:
C    0 MEANS PRODUCE LINE STRUCTURE WITH HARDWARE, AND
C    1 MEANS PRODUCE LINE STRUCTURE WITH SOFTWARE.
      INTEGER       DDXGS
C  CHARACTER SIZES AND SIZE COUNT.
      INTEGER       DDXCZ(4),DDXNC
C  BEGINNING OF PROGRAM STRING AND ITS LENGTH.
      CHARACTER*32  DDXBP
      INTEGER       DDXN1
C  END OF PROGRAM STRING AND ITS LENGTH.
      CHARACTER*32  DDXEP
      INTEGER       DDXN2
C  BEGINNING OF RECORD STRING AND ITS LENGTH.
      CHARACTER*32  DDXBR
      INTEGER       DDXN3
C  END OF RECORD STRING AND ITS LENGTH.
      CHARACTER*32  DDXER
      INTEGER       DDXN4
C  CLEAR SCREEN STRING AND ITS LENGTH.
      CHARACTER*32  DDXCL
      INTEGER       DDXN5
C  THE IDLE CHARACTER, PADDING, AND ITS COUNT.
      CHARACTER*1   DDXIL
      CHARACTER*3   DDXX1
      INTEGER       DDXNI
C  THE BELL STRING AND ITS LENGTH.
      CHARACTER*32  DDXBE
      INTEGER       DDXN6
C  CURRENT POINT INTENSITY LEVEL.
      INTEGER       DDXPI
C  CURRENT LINE TYPE.
      INTEGER       DDXLT
C  CURRENT TEXT SIZE.
      INTEGER       DDXTZ
C  FIRST END POINT FLAG:
C    .TRUE.  MEANS THIS IS THE FIRST OF A GROUP OF END POINTS, AND
C    .FALSE. MEANS IT IS NOT.
      LOGICAL       DDXFF
C  LAST POSITIONING ORDER AND PADDING.
      CHARACTER*5   DDXOP
      CHARACTER*3   DDXX2
C  PRODUCE END CLEAR PICTURE FLAG:
C    0 MEANS DO NOT PRODUCE THE PICTURE, AND
C    1 MEANS PRODUCE THE PICTURE.
      INTEGER       DDXEC
C  SUPPRESS IEBUPDTE AND TITLE RECORDS FLAG:
C    0 MEANS GENERATE THE RECORDS, AND
C    1 MEANS DO NOT GENERATE THE RECORDS.
      INTEGER       DDXTO
C  SUPPRESS ASCII TO COMPUTER TRANSLATION FLAG:
C    0 MEANS DO THE TRANSLATION, AND
C    1 MEANS DO NOT DO THE TRANSLATION.
      INTEGER       DDXAS
C  PADDING CHARACTERS BEFORE AND AFTER THE ENDREC VALUE AND PADDING.
      CHARACTER*1   DDXP1,DDXP2
      CHARACTER*2   DDXX3
C  PICTURE IDENTIFICATION (ALPHABETIC PART).
      CHARACTER*4   DDXPA
C  PICTURE IDENTIFICATION (NUMERIC PART).
      INTEGER       DDXPN
C  PICTURE ALIAS.
      CHARACTER*8   DDXPL
C  PICTURE ALIAS (DEFERRED VALUE).
      CHARACTER*8   DDXDL
C  PICTURE AVAILABLE FLAG:
C    0 MEANS NO PREVIOUS PICTURE IS AVAILABLE, AND
C    1 MEANS A PICTURE HAS PREVIOUSLY BEEN PRODUCED.
      INTEGER       DDXPV
C  DEFERRED CLEAR FLAG:
C    0 MEANS THE START OF A NEW PICTURE HAS NOT BEEN DEFERRED, AND
C    1 MEANS THE START OF A NEW PICTURE HAS BEEN DEFERRED.
      INTEGER       DDXDC
C  INPUT/OUTPUT IDENTIFICATION VALUE.
      INTEGER       DDXIO
C  THE FOLLOWING ARRAY OVERLAYS THE ENTIRE DDA EXTENSION.
      INTEGER       DDXRY(DDXZZ)
      EQUIVALENCE   (DDXRY(1),DDXID)
